#!/bin/bash
## adddriver.sh script to add smartpqi driver to the newely installed kernel..###
## these script has to be
## executed after OS has been installed on any Microchip smartRAID/HBA controller ####
## Based on solaris OS Installation method,
## live media or text installer,
## commands to be executed will vary.. #####

if [ $# -lt 1 ] ; then
	echo "Parameter error, Usage: ./adddriver.sh [ parameter (live|text) ]"
	exit
fi

parm="$1"

case ${parm} in
live)
	#echo "These case shall executed on solaris live media installation"
	#remove in-box aac driver on mounted root fs of newly installed disk
	rem_drv -b /a aac
	#adding smartpqi driver
	add_drv -b /a -m '* 0600 root sys' -i '"pci9005,28f" "pci9005,323c" "pciex9005,28f" "pciex9005,323c" "pci9005,291" "pciex9005,291"' -c scsi smartpqi
	#add rule in devlink tab file to create device node for ioctl's
	echo "type=ddi_pseudo;minor=smartpqi	smartpqi\N0" >> /a/etc/devlink.tab
	# update the boot archive for the newly installed disk
	bootadm update-archive -R /a
	;;
text)
	#echo " These case shall executed on solaris text installer installation"
	zfs set mountpoint=/pool rpool/ROOT/solaris
	zfs mount rpool/ROOT/solaris
	rem_drv -b /pool aac
 	add_drv -b /pool -m '* 0600 root sys' -i '"pci9005,28f" "pci9005,323c" "pciex9005,28f" "pciex9005,323c" "pci9005,291" "pciex9005,291"' -c scsi smartpqi
	#add rule in devlink tab file to create device node for ioctl's
	echo "type=ddi_pseudo;minor=smartpqi	smartpqi\N0" >> /pool/etc/devlink.tab
	bootadm update-archive -R /pool
	zfs umount rpool/ROOT/solaris
	zfs set mountpoint=/ rpool/ROOT/solaris
	;;
*)	echo "Invalid parameter" ;;
esac
exit 0
